// modelSwarm.java

import swarm.Globals;
import swarm.Selector;
import swarm.defobj.Zone;
import swarm.defobj.SymbolImpl;
import swarm.defobj.FArguments;
import swarm.defobj.FArgumentsImpl;
import swarm.defobj.FCall;
import swarm.defobj.FCallImpl;
import swarm.activity.Activity;
import swarm.activity.ActionGroup;
import swarm.activity.ActionGroupImpl;
import swarm.activity.Schedule;
import swarm.activity.ScheduleImpl;
import swarm.activity.FActionForEach;
import swarm.objectbase.Swarm;
import swarm.objectbase.SwarmImpl;

public class ModelSwarm extends SwarmImpl
	{
	// global variables for the class
	public Schedule modelSchedule;
	public ActionGroup modelActions;
	public Consumer aConsumer;
	public int modelTime;

	// constructor for modelSwarm
	public ModelSwarm (Zone aZone)
		{
		super(aZone);
		modelTime=0;
		}

	// build the consumer object
	public Object buildObjects()
		{
		int budget=10;
		int name=1;

		super.buildObjects();
		aConsumer=new Consumer(getZone(),name,budget);
		return this;
		}

	// define the marketDay actions
	public Object marketDay()
		{
		int go;
		int spending;

		go=aConsumer.goToTheMarket();

		if (go==1)
			{
			spending=aConsumer.spend();
			System.out.println("This is time "+modelTime);
			System.out.println("I am consumer " + aConsumer.getConsumerName() + ", I went to the market and spent " + spending +".");
			System.out.println("I have " + aConsumer.calculateRemainingBudget() + " of currency left.");
			}
		else
			{
			System.out.println("This is time "+modelTime);
			System.out.println("I am consumer " + aConsumer.getConsumerName() + ", I did not go to the market.");
			System.out.println("I have " + aConsumer.getBudget() + " of currency left.");
			}
		return this;
		}

	// build actions
	public Object buildActions()
		{
		// create the action group for all actions to be performed
		// at each time	(it is trivial, and not necessary here, as
		// there is only one action: marketDay)
		modelActions=new ActionGroupImpl(getZone());
		try
			{
			modelActions.createActionTo$message(this,
			new Selector(getClass(),"marketDay",false));
			}
		catch (Exception e)
			{
			e.printStackTrace(System.err);
			System.exit(1);
			}

		// now schedule the actions in time
		modelSchedule=new ScheduleImpl(getZone());
		modelSchedule.at$createAction(0,modelActions);
		return this;
		}

	// activity
	public Activity activateIn(Swarm swarmContext)
		{
		super.activateIn(swarmContext);
		modelSchedule.activateIn(this);
		return this.getActivity();
		}
	
	}// end of class modelSwarm